%global rocm_version 1.6.4

Name:		rocblas
Version:	0.10.3.0
Release:	3.rocm%{rocm_version}%{?dist}
Summary:	ROCm BLAS implementation

License:	MIT
URL:		https://github.com/ROCmSoftwarePlatform/rocBLAS
Source0:	https://github.com/ROCmSoftwarePlatform/rocBLAS/archive/v%{version}/rocblas-%{version}.tar.gz
Source1:	https://github.com/ROCmSoftwarePlatform/Tensile/archive/v3.4.0/tensile-v3.4.0.tar.gz
Patch0:		0001-Install-to-standard-prefix.patch
Patch1:		0001-Don-t-try-to-download-tensile-source.patch

BuildRequires:	cmake
BuildRequires:	hcc
BuildRequires:	hip
BuildRequires:	rocm-cmake
BuildRequires:	rocm-runtime-devel

# For tensile
BuildRequires:	python-yaml

%{!?enable_llvmtoolset7: %define enable_llvmtoolset7 %{nil}}
%{!?enable_devtoolset7: %define enable_devtoolset7 %{nil}}

%if 0%{?rhel} == 7
# FIXME: Manually define enable_llvmtoolset7 until llvm-toolset-7-5.0.1 is
# available
%enable_llvmtoolset7 %global ___build_pre %{___build_pre}; source scl_source enable llvm-toolset-7 || :

BuildRequires: llvm-toolset-7-cmake
BuildRequires: llvm-toolset-7-runtime
BuildRequires: devtoolset-7-build

%enable_llvmtoolset7
%enable_devtoolset7
%global __cmake cmake
%endif

%description
BLAS implementation in HIP for ROCm runtime and toolchain

%package devel
Summary: rocblas development files
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description devel
Libraries and header files for rocblas


%prep
%autosetup -p1 -n rocBLAS-%{version}


%build
mkdir -p build/extern
mv %{SOURCE1} build/extern
cd build

# hcc does not support the default CXXFLAGS, so we can't use the cmake macro:
cmake .. \
	-DCMAKE_BUILD_TYPE=RELWITHDEBINFO \
	-DCMAKE_CXX_COMPILER=%{_bindir}/hcc \
	-DCMAKE_INSTALL_PREFIX=/usr

make %{?_smp_mflags}


%install
cd build
%make_install

%files
%license LICENSE.md
%doc README.md
%{_libdir}/librocblas.so.*

%files devel
%{_libdir}/librocblas.so
%{_libdir}/cmake/rocblas/
%{_includedir}/*


%changelog
* Tue Mar 13 2018 Tom Stellard <tstellar@redhat.com> - 0.10.3.0-3.rocm1.6.4
- Add epel support

* Fri Mar 02 2018 Tom Stellard <tstellar@redhat.com> - 0.10.3.0-2.rocm1.6.4
- Enable tensile

* Fri Feb 16 2018 Tom Stellard <tstellar@redhat.com> - 0.10.3.0-1.rocm1.6.4
- 0.10.3.0 Release
